/*
    Copyright (c) 2010 digitalSTROM.org, Zurich, Switzerland

    Author: Patrick Staehlin, futureLAB AG <pstaehlin@futurelab.ch>

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef SIMMETERINGBUSINTERFACE_H_
#define SIMMETERINGBUSINTERFACE_H_

#include "src/businterface.h"

namespace dss {

  class DSSim;

  class SimMeteringBusInterface : public MeteringBusInterface {
  public:
    SimMeteringBusInterface(boost::shared_ptr<DSSim> _pSimulation)
    : m_pSimulation(_pSimulation),
      m_pEventSink(NULL)
    { }

    virtual void requestMeterData();
    virtual unsigned long getPowerConsumption(const dss_dsid_t& _dsMeterID);
    virtual unsigned long getEnergyMeterValue(const dss_dsid_t& _dsMeterID);

    void setBusEventSink(BusEventSink* _value);
  private:
    boost::shared_ptr<DSSim> m_pSimulation;
    BusEventSink* m_pEventSink;
  }; // SimMeteringBusInterface

} // namespace dss

#endif
